﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using SciChartSimpleControl.SciChartSurfaceControl.Model;
using SciChartSimpleControl.SciChartSurfaceControl.ViewModel;

namespace SciChartSimpleControl
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        public void ShowData(WrappedValuesViewModel data)
        {
            SciChartSimpleUserControlInstance.ShowData(data);
        }
        public void ClearData()
        {
            SciChartSimpleUserControlInstance.ClearData();
        }
        public void ChangeChartType(ChartTypes newType)
        {
            SciChartSimpleUserControlInstance.ChangeChartType( newType);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            // uncomment this to crush:
            ChangeChartType(ChartTypes.Array);

            List<DateTimeDoubleValue> values = new List<DateTimeDoubleValue>();
            values.Add(new DateTimeDoubleValue(DateTime.Now.AddMinutes(-5), 2));
            values.Add(new DateTimeDoubleValue(DateTime.Now.AddMinutes(-4), 5));
            values.Add(new DateTimeDoubleValue(DateTime.Now.AddMinutes(-3), 1));
            values.Add(new DateTimeDoubleValue(DateTime.Now.AddMinutes(-2), 4));

            double[] arr = new double[] { 1, 3, 2, 5 };
            WrappedValuesViewModel dummyValues = new WrappedValuesViewModel() { HistoricalValues = values, RawValue  = arr};
            ShowData(dummyValues);

        }
    }
}
