﻿using System;
using System.Windows.Threading;
using SciChartSimpleControl.SciChartSurfaceControl.ViewModel;
using SciChartSimpleControl.SciChartSurfaceControl.View;
using TikFramework.View;
using System.Windows;
using SciChart.Core;
using System.Diagnostics;
using System.Windows.Input;
using SciChart.Charting.Visuals.Annotations;
using System.Windows.Media;

namespace SciChartSimpleControl.SciChartSurfaceControl.View
{
    /// <summary>
    /// Interaction logic for SciChartSurfaceView.xaml
    /// </summary>
    public partial class SciChartSurfaceView : BaseControl<SciChartSurfaceViewModel> ,ISciChartSurfaceControlView
    {
        public SciChartSurfaceView()
        {
            InitializeComponent();
        }
        public SciChartSurfaceView(SciChartSurfaceViewModel vm)
            : this()
        {
            ViewModel = vm;
        }

        private void SeriesSelectionModifier_OnSelectionChanged(object sender, EventArgs e)
        {
            ((SciChartSurfaceViewModel)DataContext).SelectionChangedCommand.Execute(null);
        }

        private void ChartToClipboard_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var bmp = SciChartSurfaceInstance.ExportToBitmapSource();
            Clipboard.SetImage(bmp);
            System.Windows.MessageBox.Show("Скопировано в буфер!");
        }

        private void ChartToHDD_Click(object sender, RoutedEventArgs e)
        {
            var dialog = new Microsoft.Win32.SaveFileDialog();
            dialog.DefaultExt = "png";
            dialog.AddExtension = true;
            dialog.Filter = "Png Files|*.png";
            dialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            if (dialog.ShowDialog() == true)
            {
                SciChartSurfaceInstance.ExportToFile(dialog.FileName, ExportType.Png, false );
                Process.Start(dialog.FileName);
            }
        }

        private void CreateSliceClick(object sender, RoutedEventArgs e)
        {
            var zoomstate = ((SciChartSurfaceViewModel)DataContext).ZoomEnabled; //WORKAROUND
            if (SciChartSurfaceInstance.YAxes.Count != 0)
            {
                ((SciChartSurfaceViewModel)DataContext).ZoomEnabled = true;
                MouseButtonEventHandler mouseClick = null;
                ((SciChartSurfaceViewModel)DataContext).SelectionModifierEnabled = false;
                mouseClick = (s, arg) =>
                {
                    this.MouseLeftButtonUp -= mouseClick;
                    ((SciChartSurfaceViewModel)DataContext).ZoomEnabled = zoomstate;
                    //hintText.Visibility = Visibility.Collapsed;
                    double mousePoint = arg.GetPosition((UIElement)this.SciChartSurfaceInstance.GridLinesPanel).X;

                    var val = SciChartSurfaceInstance.XAxes[0].GetDataValue(mousePoint);
                    ((SciChartSurfaceViewModel)DataContext).AddSliceCommand.Execute(val);

                    //string axisId = SciChartSurfaceInstance.YAxes[0].Id;
                    //string XaxisId = SciChartSurfaceInstance.XAxes[0].Id;
                    //var slice = new VerticalLineAnnotation()
                    //{
                    //    X1 = val,
                    //    YAxisId = axisId,
                    //    XAxisId = XaxisId,
                    //    FontSize = 12,
                    //    ShowLabel = true,
                    //    Stroke = new SolidColorBrush(Colors.DarkBlue),
                    //    LabelPlacement = SciChart.Charting.Visuals.Annotations.LabelPlacement.Bottom,
                    //    StrokeThickness = 2,
                    //    IsEditable = true
                    //};
                    ////slice.LostMouseCapture += new MouseEventHandler(SliceLostCapture);
                    //sliceModifier.VerticalLines.Add(slice);
                    ////RecalculateModulationDepth();
                    ((SciChartSurfaceViewModel)DataContext).SelectionModifierEnabled = true;
                };

                //hintText.Visibility = Visibility.Visible;
                this.MouseLeftButtonUp += mouseClick;
            }
        }

        private void RemoveSliceClick(object sender, RoutedEventArgs e)
        {
            ((SciChartSurfaceViewModel)DataContext).RemoveSliceCommand.Execute(null);

            //VerticalLineAnnotation lineToDelete = null;
            //foreach (VerticalLineAnnotation line in sliceModifier.VerticalLines)
            //{
            //    if (line.IsSelected)
            //    {
            //        lineToDelete = line;
            //    }
            //}
            //if (lineToDelete != null)
            //{
            //    sliceModifier.VerticalLines.Remove(lineToDelete);
            //}
        }
    }
}
