﻿using SciChart.Charting.Model.ChartSeries;
using SciChart.Charting.Model.DataSeries;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SciChartSimpleControl.SciChartSurfaceControl.Model;
using SciChartSimpleControl.SciChartSurfaceControl.ViewModel;
using TikFramework.ViewModel;
using System.Windows.Media;

namespace SciChartSimpleControl.SciChartSurfaceControl.ViewModel
{
    class DataSeriesWithTypeViewModel : BaseViewModel
    {
        public DataSeriesWithTypeViewModel(IDataSeries dataseries, ChartTypes chartType, SeriesTypes seriesType, Color stroke, bool partial = false )
        {
            DataSeries = dataseries;
            ChartType = chartType;
            SeriesType = seriesType;
            Stroke = stroke;
            PrepareRenderableSeries(partial);
        }
        public IDataSeries DataSeries;
        public SeriesTypes SeriesType;
        public ChartTypes ChartType;
        public Color Stroke;
        private IRenderableSeriesViewModel _RenderableSeries;
        public IRenderableSeriesViewModel RenderableSeries { get { return _RenderableSeries; } set { Set(ref _RenderableSeries, value); } }
        public void PrepareRenderableSeries (bool partial)
        {
            if ( DataSeries == null)
            {
                return;
            }
            if (partial)
            {
                var cutSeries = GetCutSeriesCopy();
                RenderableSeries = ViewModelsFactory.New(SeriesType, 0, cutSeries);
                RenderableSeries.Stroke = Stroke;
                //RenderableSeries.PaletteProvider = new CurrentRevPaletteProvider() { RevStartIndex = 0 };
            }
            else
            {
                RenderableSeries = ViewModelsFactory.New(SeriesType, 0, DataSeries);
                RenderableSeries.Stroke = Stroke;
                //RenderableSeries.PaletteProvider = new CurrentRevPaletteProvider() { RevStartIndex = int.MaxValue };
            }
        }
        public IDataSeries GetCutSeriesCopy()
        {
            IDataSeries cutSeries;
            if (ChartType == ChartTypes.History)
            {
                cutSeries = new XyDataSeries<DateTime, double>();
            }
            else
            {
                cutSeries = new XyDataSeries<double, double>();
                cutSeries.AcceptsUnsortedData = DataSeries.AcceptsUnsortedData;
            }
            return cutSeries;
        }
    }
}
